from bs4 import BeautifulSoup
import ebooklib
from ebooklib import epub
import re

BLACKLIST = ['[document]',   'noscript', 'header',
             'html', 'meta', 'head', 'input', 'script', ]
# there may be more elements you don't want, such as "style", etc.


def epub2thtml(epub_path):
    book = epub.read_epub(epub_path)
    chapters = []
    for item in book.get_items():
        if item.get_type() == ebooklib.ITEM_DOCUMENT:
            chapters.append(item.get_content())
    return chapters


def chap2text(chap):
    output = ''
    soup = BeautifulSoup(chap, 'html.parser')
    text = soup.find_all(text=True)
    for t in text:
        if t.parent.name not in BLACKLIST:
            output += f'{t} '
    return output


def thtml2ttext(thtml):
    Output = []
    for html in thtml:
        text = chap2text(html)
        Output.append(text)
    return Output


def epub2text(epub_path):
    chapters = epub2thtml(epub_path)
    ttext = thtml2ttext(chapters)
    return ttext
